;================================================================
;macros, values, exe-specific values
;================================================================

MACRO WRITE_EXE_CODE file_offset,code_data,code_size,errortext {
	mov eax,file_offset
	sub eax,00400000h
invoke SetFilePointer,ebx,eax,0,FILE_BEGIN

invoke WriteFile,ebx,code_data,code_size,byteswritten,0
	mov ecx,[byteswritten]
	test eax,eax
	mov edi,errortext
	    jz MAINEXIT
	cmp ecx,code_size
	    jnz MAINEXIT
	}

;=================================================================

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

virtual at esi
	freespace_addr	dd	?
	maincode_addr	dd	?
	entrypoint	dd	?
	entry_call	dd	?
	exit_call	dd	?
	exit_addr_1	dd	?
	exit_addr_2	dd	?
	maincode_length dd	?
 label	exe_name
end virtual

;================================================================

MACRO MAIN_CODE _exitprocess,_loadlib,_freelib,\
		_msgbox,_getmoduleh,_unload_dword_addr
{
local Initialize,End_Initialize,CouldNotLoadATX,Unload,\
	_msgcapt,_msgtext,_mxtname

Initialize:
push ebx
push ecx
push edx
push esi
push edi
push ebp

push _mxtname
call DWORD [_loadlib]		;load ATYPEX.DLL
test eax,eax
jz CouldNotLoadATX

pop ebp
pop edi
pop esi
pop edx
pop ecx
pop ebx
	pop eax
push ebp			;replaced code at entry point
mov ebp,esp
push 0FFFFFFFFh
jmp eax 			;continue trespasser

CouldNotLoadATX:
pop ebp
pop edi
pop esi
pop edx
pop ecx
pop ebx
	add esp,4
push 0
push _msgcapt
push _msgtext
push 0
call DWORD [_msgbox]
push 0
call DWORD [_exitprocess]

End_Initialize:

Unload:
push _mxtname
call DWORD [_getmoduleh]
push eax
call DWORD [_freelib]

push DWORD [esp+4]		;exit code
call DWORD [_exitprocess]
ret

_mxtname	db	"ATYPEX.DLL",0
_msgcapt	db	"ATX ERROR",0
_msgtext	db	"Error loading ATYPEX.DLL",0

_unload_dword_addr	dd	Unload

}
;================================================================