;============================================================
;VALUES FOR ATYPEX.DLL AND INCLUDED SOURCE FILES
;============================================================

;====================================================================
;GENERAL VALUES
;====================================================================
SLIDER_GAME_DIFFICULY_ID	equ	1956
SLIDER_DRAW_DISTANCE_ID 	equ	1794
CHECKBOX_MATRIX_ID		equ	1869
CHECKBOX_RANDOM_DINOS_ID	equ	1867
CHECKBOX_JUMP_DINOS_ID		equ	1868

;text display vertical coordinates
FACE_FLOATS_MSG        equ     00h
PLAYERHEALTH_MSG       equ     00h
TIME_STAMP_MSG	       equ     2Eh
SHOW_DRAW_DIST_MSG     equ     3Eh
KEY_STATE_MSG	       equ     4Eh
ERROR_LOG_MSG_VERT     equ     5Eh
Base_CAnimal_display   equ     70h

DotBlinkSpeed		equ	400

_exe_P6_1_1_Size	equ	2555904 	;EXE sizes for detection
_exe_P5_1_1_Size	equ	2580480
_exe_K6_1_1_Size	equ	2351104
_exe_P5_Demo_Size	equ	2600960

value_int		equ	3		;ID types from T-Script
value_float		equ	4
value_string		equ	5
value_group		equ	6
value_bool		equ	1

;T-SCRIPT ENTRIES
;THESE ARE THE DISPLACEMENT VALUES SPECIFIC TO T-SCRIPT ENTRIES
;THAT ARE ADDED TO THE BASE ID TABLE ADDRESS AND PASSED TO THE
;GetEntryValueProc FUNCTION

Ammo		equ	027F8h
AltAmmoCount	equ	02818h
Frame		equ	014D0h
Interval	equ	012D8h
LoopCount	equ	00FA8h
MaxAmmo 	equ	02800h
Target		equ	003D8h		;doesn't work well
Sample		equ	00F48h
Speed		equ	02A18h
XPos		equ	00FE0h
YPos		equ	00FE8h
X		equ	011F8h
Y		equ	01200h
WakeUp		equ	02A58h
Sleep		equ	02A60h
ActGetOut	equ	(052Eh*8)+2A8h
HitPoints	equ	00408h
MaxHitPoints	equ	00410h

DOES_NOT_APPLY_TO_EXE	equ	0

default_fast_fly_speed		equ	0.400000
default_normal_fly_speed	equ	0.200000
default_key_fly_delay		equ	10

canimal_emos_count	equ  (canimal_emos_text_table_end-canimal_emos_text_table)/4

;====================================================================
;DIRECTX
;====================================================================
;Some DirectX structures and constants, not necessarily used

DDLOCK_WAIT	=	00000001

struc DDCOLORKEY  {
  .dwColorSpaceLowValue  dd ?
  .dwColorSpaceHighValue dd ?
}

struc DDPIXELFORMAT {
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwFourCC	   dd ?
  label .dwYUVBitCount	   dword
  label .dwZBufferBitDepth dword
  label .dwAlphaBitDepth   dword
	.dwRGBBitCount	   dd ?
  label .dwYBitMask	   dword
	.dwRBitMask	   dd ?
  label .dwUBitMask	   dword
	.dwGBitMask	   dd ?
  label .dwVBitMask	   dword
	.dwBBitMask	   dd ?
  label .dwYUVAlphaBitMask dword
  label .dwRGBZBitMask	   dword
  label .dwYUVZBitMask	   dword
	.dwRGBAlphaBitMask dd ?
}

struc DDSCAPS2 {
  .dwCaps  dd ?
  .dwCaps2 dd ?
  .dwCaps3 dd ?
  .dwCaps4 dd ?
}

struc DDSURFACEDESC2 {
	.dwSize 	   dd ?
	.dwFlags	   dd ?
	.dwHeight	   dd ?
	.dwWidth	   dd ?
  label .dwLinearSize	   dword
	.lPitch 	   dd ?
	.dwBackBufferCount dd ?
  label .dwZBufferBitDepth dword
  label .dwRefreshRate	   dword
	.dwMipMapCount	   dd ?
	.dwAlphaBitDepth   dd ?
	.dwReserved	   dd ?
	.lpSurface	   dd ?
	.ddckCKDestOverlay DDCOLORKEY
	.ddckCKDestBlt	   DDCOLORKEY
	.ddckCKSrcOverlay  DDCOLORKEY
	.ddckCKSrcBlt	   DDCOLORKEY
	.ddpfPixelFormat   DDPIXELFORMAT
	.ddsCaps	   DDSCAPS2
}

;====================================================================
;POSSIBLE CONFLICT VALUES
;====================================================================
;This/these current value(s) isn't/aren't currently implemented
;in FASM's include library at this time, but may be in the future
;and cause conflicts. Delete if this happens to be the case.

DIB_RGB_COLORS		equ 0	;remove if conflict with include files


;VIDEO CAPTURE MESSAGES

0L			    equ 0
WM_CAP_START		    equ WM_USER
WM_CAP_UNICODE_START	    equ WM_USER+100
WM_CAP_GET_CAPSTREAMPTR     equ WM_CAP_START+1
WM_CAP_SET_CALLBACK_ERRORW  equ WM_CAP_UNICODE_START+2
WM_CAP_SET_CALLBACK_STATUSW equ WM_CAP_UNICODE_START+3
WM_CAP_SET_CALLBACK_ERRORA  equ WM_CAP_START+2
WM_CAP_SET_CALLBACK_STATUSA equ WM_CAP_START+3
WM_CAP_SET_CALLBACK_YIELD   equ WM_CAP_START+4
WM_CAP_SET_CALLBACK_FRAME   equ WM_CAP_START+5
WM_CAP_SET_CALLBACK_VIDEOSTREAM equ WM_CAP_START+6
WM_CAP_SET_CALLBACK_WAVESTREAM equ WM_CAP_START+7
WM_CAP_GET_USER_DATA	    equ WM_CAP_START+8
WM_CAP_SET_USER_DATA	    equ WM_CAP_START+9
WM_CAP_DRIVER_CONNECT	    equ WM_CAP_START+10
WM_CAP_DRIVER_DISCONNECT    equ WM_CAP_START+11
WM_CAP_DRIVER_GET_NAMEA     equ WM_CAP_START+12
WM_CAP_DRIVER_GET_VERSIONA  equ WM_CAP_START+13
WM_CAP_DRIVER_GET_NAMEW     equ WM_CAP_UNICODE_START+12
WM_CAP_DRIVER_GET_VERSIONW  equ WM_CAP_UNICODE_START+13
WM_CAP_DRIVER_GET_CAPS	    equ WM_CAP_START+14
WM_CAP_FILE_SET_CAPTURE_FILEA equ WM_CAP_START+20
WM_CAP_FILE_GET_CAPTURE_FILEA equ WM_CAP_START+21
WM_CAP_FILE_SAVEASA	    equ WM_CAP_START+23
WM_CAP_FILE_SAVEDIBA	    equ WM_CAP_START+25
WM_CAP_FILE_SET_CAPTURE_FILEW equ WM_CAP_UNICODE_START+20
WM_CAP_FILE_GET_CAPTURE_FILEW equ WM_CAP_UNICODE_START+21
WM_CAP_FILE_SAVEASW	    equ WM_CAP_UNICODE_START+23
WM_CAP_FILE_SAVEDIBW	    equ WM_CAP_UNICODE_START+25
WM_CAP_FILE_ALLOCATE	    equ WM_CAP_START+22
WM_CAP_FILE_SET_INFOCHUNK   equ WM_CAP_START+24
WM_CAP_EDIT_COPY	    equ WM_CAP_START+30
WM_CAP_SET_AUDIOFORMAT	    equ WM_CAP_START+35
WM_CAP_GET_AUDIOFORMAT	    equ WM_CAP_START+36
WM_CAP_DLG_VIDEOFORMAT	    equ WM_CAP_START+41
WM_CAP_DLG_VIDEOSOURCE	    equ WM_CAP_START+42
WM_CAP_DLG_VIDEODISPLAY     equ WM_CAP_START+43
WM_CAP_GET_VIDEOFORMAT	    equ WM_CAP_START+44
WM_CAP_SET_VIDEOFORMAT	    equ WM_CAP_START+45
WM_CAP_DLG_VIDEOCOMPRESSION equ WM_CAP_START+46
WM_CAP_SET_PREVIEW	    equ WM_CAP_START+50
WM_CAP_SET_OVERLAY	    equ WM_CAP_START+51
WM_CAP_SET_PREVIEWRATE	    equ WM_CAP_START+52
WM_CAP_SET_SCALE	    equ WM_CAP_START+53
WM_CAP_GET_STATUS	    equ WM_CAP_START+54
WM_CAP_SET_SCROLL	    equ WM_CAP_START+55
WM_CAP_GRAB_FRAME	    equ WM_CAP_START+60
WM_CAP_GRAB_FRAME_NOSTOP    equ WM_CAP_START+61
WM_CAP_SEQUENCE 	    equ WM_CAP_START+62
WM_CAP_SEQUENCE_NOFILE	    equ WM_CAP_START+63
WM_CAP_SET_SEQUENCE_SETUP   equ WM_CAP_START+64
WM_CAP_GET_SEQUENCE_SETUP   equ WM_CAP_START+65
WM_CAP_SET_MCI_DEVICEA	    equ WM_CAP_START+66
WM_CAP_GET_MCI_DEVICEA	    equ WM_CAP_START+67
WM_CAP_SET_MCI_DEVICEW	    equ WM_CAP_UNICODE_START+66
WM_CAP_GET_MCI_DEVICEW	    equ WM_CAP_UNICODE_START+67
WM_CAP_STOP		    equ WM_CAP_START+68
WM_CAP_ABORT		    equ WM_CAP_START+69
WM_CAP_SINGLE_FRAME_OPEN    equ WM_CAP_START+70
WM_CAP_SINGLE_FRAME_CLOSE   equ WM_CAP_START+71
WM_CAP_SINGLE_FRAME	    equ WM_CAP_START+72
WM_CAP_PAL_OPENA	    equ WM_CAP_START+80
WM_CAP_PAL_SAVEA	    equ WM_CAP_START+81
WM_CAP_PAL_OPENW	    equ WM_CAP_UNICODE_START+80
WM_CAP_PAL_SAVEW	    equ WM_CAP_UNICODE_START+81
WM_CAP_PAL_PASTE	    equ WM_CAP_START+82
WM_CAP_PAL_AUTOCREATE	    equ WM_CAP_START+83
WM_CAP_PAL_MANUALCREATE     equ WM_CAP_START+84
WM_CAP_SET_CALLBACK_CAPCONTROL equ WM_CAP_START+85
WM_CAP_UNICODE_END	    equ WM_CAP_PAL_SAVEW
WM_CAP_END		    equ WM_CAP_UNICODE_END
